summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2015-12-19 11:28:36 +0000
committerFelix Fietkau <nbd@openwrt.org>2015-12-19 11:28:36 +0000
commitc74a6906616918ee9effc5e19019896e567dc9e6 (patch)
treee96a018617fa091cf586440c4e8100126acc5627
parent8e4194797aff4f0d2c837565571757b5dccb1548 (diff)
downloadmaster-31e0f0ae-c74a6906616918ee9effc5e19019896e567dc9e6.tar.gz
master-31e0f0ae-c74a6906616918ee9effc5e19019896e567dc9e6.tar.bz2
master-31e0f0ae-c74a6906616918ee9effc5e19019896e567dc9e6.zip
ar71xx: scan nand ubi partition for ath9k eeprom files
The MR18 stores the ath9k eeprom values on the NAND. This patch makes it possible to retrieve the images from there. Signed-off-by: Chris R Blake <chrisrblake93@gmail.com> SVN-Revision: 47948
-rw-r--r--package/base-files/files/lib/functions/system.sh17
-rw-r--r--target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom21
2 files changed, 38 insertions, 0 deletions
diff --git a/package/base-files/files/lib/functions/system.sh b/package/base-files/files/lib/functions/system.sh
index 8d75a5a8ce..03d71277b0 100644
--- a/package/base-files/files/lib/functions/system.sh
+++ b/package/base-files/files/lib/functions/system.sh
@@ -41,6 +41,23 @@ mtd_get_mac_binary() {
dd bs=1 skip=$offset count=6 if=$part 2>/dev/null | hexdump -v -n 6 -e '5/1 "%02x:" 1/1 "%02x"'
}
+mtd_get_mac_binary_ubi() {
+ local mtdname="$1"
+ local offset="$2"
+
+ . /lib/upgrade/nand.sh
+
+ local ubidev=$(nand_find_ubi $CI_UBIPART)
+ local part=$(nand_find_volume $ubidev $1)
+
+ if [ -z "$part" ]; then
+ echo "mtd_get_mac_binary: ubi volume $mtdname not found!" >&2
+ return
+ fi
+
+ hexdump -v -n 6 -s $offset -e '5/1 "%02x:" 1/1 "%02x"' /dev/$part 2>/dev/null
+}
+
mtd_get_part_size() {
local part_name=$1
local first dev size erasesize name
diff --git a/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom b/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
index 33b1d74dc8..9d3356447a 100644
--- a/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
+++ b/target/linux/ar71xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
@@ -25,6 +25,21 @@ ath9k_eeprom_extract() {
ath9k_eeprom_die "failed to extract from $mtd"
}
+ath9k_ubi_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local ubidev=$(nand_find_ubi $CI_UBIPART)
+ local ubi
+
+ ubi=$(nand_find_volume $ubidev $part)
+ [ -n "$ubi" ] || \
+ ath9k_eeprom_die "no UBI volume found for $part"
+
+ dd if=/dev/$ubi of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=$count 2>/dev/null || \
+ ath9k_eeprom_die "failed to extract from $ubi"
+}
+
ath9k_patch_firmware_mac() {
local mac=$1
@@ -39,6 +54,8 @@ case "$FIRMWARE" in
"soc_wmac.eeprom")
case $board in
mr18)
+ . /lib/upgrade/nand.sh
+
if [ -n "$(nand_find_volume ubi0 caldata)" ]; then
ath9k_ubi_eeprom_extract "caldata" 4096 2048
else
@@ -61,6 +78,8 @@ case "$FIRMWARE" in
"pci_wmac0.eeprom")
case $board in
mr18)
+ . /lib/upgrade/nand.sh
+
if [ -n "$(nand_find_volume ubi0 caldata)" ]; then
ath9k_ubi_eeprom_extract "caldata" 20480 2048
else
@@ -82,6 +101,8 @@ case "$FIRMWARE" in
"pci_wmac1.eeprom")
case $board in
mr18)
+ . /lib/upgrade/nand.sh
+
if [ -n "$(nand_find_volume ubi0 caldata)" ]; then
ath9k_ubi_eeprom_extract "caldata" 36864 2048
else